;
; basic.asm - basic extensions
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;**************************************************
;Basic extensions
;
;Listing does not have problems.
;Tokenizer may have problems with irq $8000-$9fff or turned off basic...
;Token executor may have problems with irq $8000-$9fff or turned off basic...
;**************************************************
; duplicated day names!
;---------------------------
;LIST modification (cfg_open)
;
OP_mylist	.proc
		cmp #$f0		;Our codes from $f0
		bcc back
		cmp #$ff		;PI
		beq back		;C=0
		bit $0f			;" mode
		bmi back
listbank0	.global
		sbc #$ee
		tax
		sty $49
		ldy #$ff
next		dex
		beq printlp
loop		iny
		lda newcommands,y
		bpl loop
		gmi next

printlp		iny
		lda newcommands,y
		bmi end
		jsr newchrout_t		; chrout (cfg_16)
		gcc printlp

end		and #$7f
		ldy $49
back		sta $49
		#psr $a71a
		lda $49
		jmp switch_norm
		.pend
;---------------------------
;New BASIC keywords
;
newcommands	.proc
		.text "L",128+"L"	;$f0
		.text "DI",128+"R"	;$f1
		.text "C",128+"D"	;$f2
		.text "R",128+"M"	;$f3
		.text "MKDI",128+"R"	;$f4
		.text "HDINI",128+"T"	;$f5
		.text "KIL",128+"L"	;$f6
		.text "INI",128+"T"	;$f7
		.text "CHANG",128+"E"	;$f8
		.text "DAT",128+"E"	;$f9
		.text "MA",128+"N"	;$fa
		.byte 0
		.pend
;---------------------------
;Tokenizer modification (cfg_8)
;Always tokenizes from buffer $200
;
;@ <- * *(toketized?) " RVSON? / /(tokenized) % ^ ^(tokenized) ' Font
;
tokencmd	.proc
		.text "@/%",94,95,39,92,"*";* not implemented
		.pend			;but needed for JiffyDos...

LW_mytoken	.proc
		inx
		bne notdirectmode	;in program line mode...
		ldy #8
lp		cmp tokencmd-1,y
		bne notwedge

		#psr $a5e3		;REM
		ldx $7a
		ldy #4
		tya
		jmp exit2basic

notwedge	dey
		bne lp

notdirectmode	sta cfg_8
		jsr $a57c
		ldx #0
		stx $7a
		ldy #4
		sty $0f
nxtch		lda $0200,x
		bmi copy
lt128		cmp #" "
		beq copy
		sta $08
		cmp #$22
		beq quote
		bit $0f
		bvs copy
		cmp #"A"
		bcc copy
		cmp #"Z"+1
		bcs copy
		sty $71
		ldy #$70
		sty $0b
		ldy #$ff
		stx $7a
		dex
srchl		iny
		inx
testnxt		lda $0200,x
		sec
		sbc newcommands,y
		beq srchl
		cmp #$80
		bne notfnd
		ora $0b
aga		ldy $71
copy		inx
		iny
		sta $01fb,y
		cmp #$00
		beq eobuf
		sbc #$3a
		beq dt
		cmp #$49
		bne notdata
dt		sta $0f
notdata		sec
		sbc #$55
		bne nxtch
		sta $08
toend		lda $0200,x
		beq copy
		cmp $08
		beq copy
quote		iny
		sta $01fb,y
		inx
		bne toend
notfnd		ldx $7a
		inc $0b
fnexn		iny
		lda newcommands-1,y
		bpl fnexn
		lda newcommands,y
		bne testnxt
		lda $0200,x
		bpl aga
eobuf		sta $01fd,y
		lda #$ff
		sta $7a
		jmp exit2basic
		.pend
;---------------------------------------
;Token executor modification (cfg_16)
;---------------------------------------
myload		.proc
		#lda0
		.byte SKIP2
myverify       	.proc
		lda #1
		sta $0a
		sta ActualSecAddr
		lda #1
		sta ActualFNLength
		lda #$b3
		sta ActualFilename
		lda #$e1
		sta ActualFilename+1	;"*" as default filename (from kernal rom)
		#psr $e16f
mylosaback	.global
		#psr $e1e0
		jmp exit2basic
		.pend

mysave		.proc
		#psr $e159
		#lda0
		sta ActualSecAddr
		sta ActualFNLength
		geq mylosaback
		.pend

myif		.proc
		jsr cad9e		;cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
		cmp #$89		;goto?
		beq ifgoto		;C=1
		cmp #$a7		;then?
		bne syntaxe
		jsr newchrget		;C=0 if number
ifgoto		ldx $61
		bne ifthen
		#psr $a93b		;rem rest of line
		jmp exit2basic

cad9e		#psr switch_16k
		#psr $ad9e
		jmp exit2basic

ifthen		cmp #$3a		;chrgot
		bcs mydoit
		eor #$30
		cmp #$10
		eor #$30
		bcs mydoit

		.if SUPERCPU=0
		tax
		.fi
		#psr $a8a0		;goto xxx
		.if SUPERCPU=0
		txa
		.fi
		jmp exit2basic
		.pend
;----
mydoit		.proc
		beq emptycommand
		asl
		bcc nottoken
		cmp #$23+$23
		bcs overt
		tay
hackedb2	.global
		lda basic_keyw+1,y
		bpl hackedb
		pha
		lda basic_keyw,y
		pha
		jmp basexeccmd

hackedb		ora #$80
		pha
		lda basic_keyw,y
		gcc tulin

mymisc		.global
		tax
                .if SUPERCPU=0
		#sta_cfg_open
		lda JiffyDos_present_exp
		beq dud
                .fi
                #lda0
                cpx #"@"		;@# hack
                bne dud
                ldx $7a
                ldy $7b
                inc $7a
                bne *+4
                inc $7b
                jsr newchrgot
                stx $7a
                sty $7b
                ldx #"@"
                cmp #"#"
                bne dud
                lda #CMOS_DOS_WEDGE
dud     	ora setup_atribut_exp
		#sta_cfg_16
		and #CMOS_DOS_WEDGE
		beq syntaxe2
   		txa
		ldy #$e9
keudhj		cmp tokencmd-$e9,y
		beq jmpu
		iny
		cpy #$f0
		bne keudhj
syntaxe2	#psr $a9a8
		.byte SKIP1
syntaxe		.global
		tax
		#psr $af08
		txa
emptycommand	jmp exit2basic

jmpu		tya
		asl
		gcs jht

overt		.global
		cmp #$4b+$4b		;GO?
		bne notgo
		#psr $a812
		jmp exit2basic

notgo		cmp #$e0		;>$f0
		bcc syntaxe
jht		tay
		#psr exit2basic
		lda insad-$df,y
		pha
		lda insad-$e0,y
tulin		pha
		jmp newchrget		;start in cfg_16

nottoken	lsr
		ldx #$00
		stx $0c
		sta $45
		cmp #"A"
		bcc mymisc
		cmp #1+"Z"
		bcs mymisc
		jmp basnottoken

basic_keyw	.word $A830,$A741,$AD1D,$A8F7;$80
		.word $ABA4,$ABBE,$B080,$AC05;$84
		.word $A9A4,$A89F,$A870,myif-$8001;$88
		.word $A81C,$A882,$A8D1,$A93A;$8c
		.word $A82E,$A94A,$B82C,myload-$8001;$90
		.word mysave-$8001,myverify-$8001,$B3B2,$B823;$94
		.word $AA7F,$AA9F,$A856,$A69B;$98
		.word $A65D,$AA85,$E129,$E1BD;$9c
		.word $E1C6,$AB7A,$A641

					;           ,<$BC39 ;$a0
					;          .byte <$BCCC,<$BC58,<$0310,<$B37D ;$a4
					;         .byte <$B39E,<$BF71,<$E097,<$B9EA ;$a8
					;        .byte <$BFED,<$E264,<$E26B,<$E2B4 ;$ac
					;       .byte <$E30E,<$B80D,<$B77C,<$B465 ;$b0
					;      .byte <$B7AD,<$B78B,<$B6EC,<$B700 ;$b4
					;     .byte <$B72C,<$B737

		.word baserrorchannel-1	;11
		.word basloadfile0-1	;12
		.word basloadfile1-1	;13
		.word basloadfile2-1	;14
		.word bassavefile0-1	;15
		.word basverifyfile0-1	;16
		.word basloadfile3-1	;17
insad		.word basll-1		;0
		.word basdir-1		;1
		.word bascd-1		;2
		.word basdelete-1	;3
		.word basmkdir-1	;4
		.word bashdinit-1	;5
		.word baskill-1		;6
		.word basinit-1		;7
		.word baschange-1	;8
		.word basdate-1		;9
		.word manager-1		;10
		.pend
;---------------------------------------
;Basic HDINIT
;---------------------------------------
bashdinit	.proc
		sta cfg_open
		jsr OP_save_zeropage
		jsr kill_drives
                
		lda #%00000110		;SRST drives
		sta low_reg
		sta contr_g
		jsr wait_a_bit		;>5us
		lda #%00000010
		sta low_reg
		sta contr_g

		jsr wait_50ms

		#lda0
		jsr OP_hdinit
		bcs next
		bit msgmode
		bpl next
		jsr LWNO_print_imediate	;cfg_16
		.text "MASTER:",13,0
		jsr print_name;cfg_open
next	        lda #1
		jsr OP_hdinit
		bcs next2
		bit msgmode
		bpl next2
		jsr LWNO_print_imediate	;cfg_16
		.text "SLAVE:",13,0
		jsr print_name
next2		#lda0
		jsr OP_XIT_hdinit_2
		lda #1
		jsr OP_XIT_hdinit_2
		jsr OP_hdinit_drivenumbers
		jmp OP_restore_zeropage

print_name 
		ldx #216
lp		sta cfg_open
		lda ident_model_number_exp-216,x
		bmi inval
		cmp #32			;skip control chars
		bcs *+4
inval		lda #32
		cmp #97
		bcc *+4
		sbc #32
		jsr newchrout_t		; chrout (cfg_16)
		inx
		bne lp
		#sta_cfg_open
		rts
		.pend
;---------------------------------------
;Basic INIT (fills memory with 0 & softreset)
;---------------------------------------
basinit		.proc
		sei
		lda #$7f
		sta $dd0d
		lda $d011
		bpl *-3
		and #%11101111
		sta $d011
		ldx #del_ka-filler
loop		lda filler-1,x
		sta $01,x
		dex
		bne loop
		txa
		ldy #$2f
		sty $00
		ldy #$33
		jmp $02			;START !!!
;--------------------------------------
filler		.logical $0002
		sty $01
lp		sta $0100,x
		sta $8000,x
		inx
		bne lp
		inc lp+2
		inc lp+5
		bne lp
                .if SUPERCPU=1
                lda #$37
                .else
		sta $00			;Does not work on SCPU!
                .fi
		sta $01
		jmp cart_reset		;!!!!!!
		.here
del_ka		.pend
;---------------------------------------
;Basic KILL (switches off cartridge)
;---------------------------------------
baskill		.proc
		sei
		jsr LWNO_set_old314vect
                jsr exit_c128key
		jsr LWNO_basic_exit
		#sta_cfg_open
		ldx #del_ka2-exiter
loop		lda exiter-1,x
		sta $1ff,x
		dex
		bne loop
;		txa
;		jsr offdrive
;		lda #1
;		jsr offdrive
notpresent2	jsr LWNO_print_imediate	;cfg_16
		.text "BYE!",13,0
		lda #1
		jmp $200		;START !!!
;--------------------------------------
exiter		sta cfg_stnd
		sta kill_port
		jmp ($a002)
del_ka2		.pend
;---------------------------------------
;Basic DATE (prints date and time)
;---------------------------------------
basdate		.proc
                jsr bas_optional_devnum
                
                ldx #<tra
                ldy #>tra
                jsr bas_commandc
                jsr bas_open15
                jmp baserrorchannel.errinlp

tra		.text "T-RA",0
;---------------------------------------
;Basic @ (Read error channel)
;---------------------------------------
baserrorchannel	.proc
		cmp #"#"
		bne noch
                ldx #<($b79b-1)
                ldy #>($b79b-1)
                jsr far
		stx ActualDev
                .if SUPERCPU=0
                #sta_cfg_open
		lda JiffyDos_present_exp
                #sta_cfg_16
		beq n
                .fi
		stx $be			;Jiffydos...
n		cpx #$4
		bcs *+3
                rts
                #lda0
		sta ActualSecAddr
                sta ActualFNLength
		jsr bas_open2
                jmp bas_close

noch		jsr calcfnlength
		#sta_cfg_open
                jsr OP_copy_filename_to_path
                lda path_exp
		eor #"$"
		bne noch2
		jsr tryopenfile
dir     	jsr bas_xchrin          ;Skip load address
	     	jsr bas_xchrin          ;Skip load address
lp		jsr bas_xchrin		;Skip linking
		jsr bas_xchrin		;Skip linking
		lda #13
		jsr newchrout_t
		jsr bas_xchrin		;Filesize
                tax
		jsr bas_xchrin		;Filesize
		jsr printaxnum		;Print size
		lda #32
euo		jsr newchrout_t		;Print name
		jsr bas_xchrin
		tax
		bne euo
		jsr check_stop		;Stop?
		bne lp
		geq fileerror

tryopenfile	sta ActualSecAddr
		jsr bas_devcheck
		jmp bas_open

noch2		lda #15
		jsr tryopenfile	        ;Exec command
errinlp		jsr newchrin_t		;Print error channel
		ldx Status
		jsr newchrout_t
		txa
		beq errinlp

fileerror	jmp bas_close
		.pend
;---------------------------
;Calculate filename length and position for BASIC wedge commands
;
calcfnlength	.proc
		lda $7a
                sta ActualFilename
		lda $7b
		sta ActualFilename+1
                jsr newchrgot
                ldy #0
                geq xx

lp		iny
		jsr newchrget
xx		ora #0
		beq dxb
                cmp #$22
                bne lp
                
                ldx #<($e257-1)
                ldy #>($e257-1)
                jsr far
                jsr newchrgot
                beq ti
                cmp #","
                bne ti
                ldx #<($e200-1)
                ldy #>($e200-1)
                jmp bas_optional_devnum.in
ti		rts

dxb		lda $7a
		sec
		sbc ActualFilename
                sta ActualFNLength
		rts
		.pend
;---------------------------
;Kill rest of basic line
;
eatglp		jsr newchrget		;otherwise there will be some problems in $8000-
eatg		sta cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
;		cmp #0
		bne eatglp
		rts
;---------------------------
;Print decimal number in A/X
;
printaxnum	.proc
		tay
		sta cfg_open

		lda buffer_output_exp
		eor #STDOUT
		bne nonstandard
		lda buffer_input_exp
		cmp #STDIN
		bne nonstandard
		#psr gotobank3back
		gcs standard

nonstandard	#psr switch_16k
standard	#psr $bdcd
		tya
		jmp exit2basic
		.pend
;---------------------------------------
;Basic / % ^ (load file)
;---------------------------------------
basloadfile3	.proc
		lda #$80
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile1
		.pend

basloadfile2	.proc
		lda #1
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile0
		.pend

basverifyfile0	lda #1
		tax
		gne basloadin
basloadfile1	ldx #1
		.byte SKIP2
basloadfile0	ldx #0
		#lda0
basloadin	stx ActualSecAddr
		stx $14
		pha
		jsr calcfnlength
		jsr eatg
                pla
                sta $0a
                ldx $2b
                ldy $2c
                jsr newload_t
                bcs bas_ioerror
                lda Status
                ldx $0a
                beq load
                ldx #$1c	;verify error
                and #$10
                bne err2
                #psr $e18d
                jmp exit2basic

load		ldx #$1d	;load error
		and #$bf
                bne err2
                lda $7b
                cmp #>$200
                bne prog
                stx $2d
                sty $2e
nu              rts

prog		lda $14
		bne nu
                #psr $e1b5
                jmp exit2basic
                
err2		txa                
err		jmp bas_ioerror

bassavefile0	.proc
		#stz_a ActualSecAddr
		jsr calcfnlength
		jsr eatg
                pla
                pla
		#psr $e159
		jmp exit2basic
		.pend
;---------------------------------------
;Basic LL and DIR common stuff
;---------------------------------------
dir_common     	.proc
tmp		=$ae
		ldx #<dirtxt
		ldy #>dirtxt
		stx tmp
		sty tmp+1
		jsr bas_optional_name_and_devnum
                #jmps bas_common.in

dirtxt		.text "$",0
;---------------------------------------
;Basic CD, MKDIR and RM common stuff
;---------------------------------------
bas_common	.proc
tmp		=$ae
		stx tmp
		sty tmp+1
		jsr bas_required_name_and_devnum
in              #sta_cfg_open
                jsr OP_copy_filename_to_path
		#jmps bas_commandc.in
;---------------------------------------
;Common command stuff
;---------------------------------------
bas_commandc	.proc
tmp		=$ae
		stx tmp
		sty tmp+1
		#lda0
                #sta_cfg_open
                sta path_exp
in              .if SUPERCPU=1
                tsc
                .else
                tsx
                txa
                .fi
                sbc #10
                bcc bas_outofmemory
                sta ActualFNLength
                ldy #0                
kk              lda (tmp),y
		beq endprefix
                sta $100,y
                iny
                cpy ActualFNLength
                bcc kk
endprefix	ldx #0
nnu             lda path_exp,x
		beq exu
		sta $100,y
		inx
                iny
                cpy ActualFNLength
                bcc nnu
exu	    	sty ActualFNLength
                ldx #1
                stx ActualFilename+1
                .if SUPERCPU=1
                stz ActualFilename
                .else
                dex
                stx ActualFilename
                .fi
                #sta_cfg_16
                rts
                .pend
;---------------------------------------
;Basic CDOPEN
;---------------------------------------
bascdopencl   	.proc
		pha
                jsr newchrget
		jsr bas_optional_devnum
                pla
		ldx #<open
		ldy #>open
                cmp #$9f
                beq ii
                ldx #<close
                ldy #>close
ii              jsr bas_commandc
                jsr bas_open15
                jmp bas_checkerrorclose
open            .text "U0>E1",0
close           .text "U0>E0",0
;---------------------------------------
;Basic CD
;---------------------------------------                
bascd		.proc
		cmp #$a0	;close
                beq bascdopencl
		cmp #$9f	;open
                beq bascdopencl
                
		ldx #<cdtxt
		ldy #>cdtxt
in		jsr bas_common
		jsr bas_open15
                jsr bas_checkerrorclose
                lda #4		;file not found
                bcs bas_filenotf
                rts
cdtxt           .text "CD:",0
                .pend
;---------------------------------------
;Basic RM
;---------------------------------------                
basdelete	.proc
		cmp #$f1
                bne ns
                jsr newchrget
                ldx #<rdtxt
                ldy #>rdtxt
                gne bascd.in

ns		ldx #<stxt
                ldy #>stxt
                gne bascd.in
stxt            .text "S:",0
rdtxt           .text "RD:",0
		.pend
;---------------------------------------
;Basic MKDIR
;---------------------------------------                
basmkdir	.proc
		ldx #<mdtxt
                ldy #>mdtxt
                gne bascd.in
mdtxt           .text "MD:",0
		.pend
;---------------------------------------
;Basic DIR
;---------------------------------------                
basdir  	.proc
		jsr dir_common
                #lda0
		jsr bas_openthis
                #jmps baserrorchannel.dir
                .pend
;---------------------------------------
;Basic LL
;---------------------------------------                
basll		.proc
buff		=$100
tmp		=$ae

		jsr dir_common
                lda #2
		jsr bas_openthis
ce
                tsx
                cpx #40
                bcc bas_outofmemory

		jsr bas_xchrin
                cmp #"I"
                beq re
                cmp #"A"
                beq r1541
                cmp #"D"
                beq xx
                cmp #"H"
                bne fileerror
xx              geq r1581

re              jsr check_stop		;Stop?
		beq fileerror
	
		ldx #0
le              jsr bas_xchrin
                sta buff,x
                inx
                cpx #32
                bcc le

                ldx #0

                lda buff+$18
                and #FATTR_CLOSED | FTYPE_MASK
                beq re
                and #FTYPE_MASK
                cmp #FTYPE_RELATIVE
                bne ks
iu              stx buff+$13
ks
                tax
                lda Status
                pha

		lda #13
                jsr newchrout_t
                
                lda ft,x
                jsr newchrout_t
                
                ldx #4
                lda buff+$18
lu              asl
                pha
                lda fa,x
                bcs *+4
                lda #"-"
                jsr newchrout_t
                pla
                dex
                bpl lu

                lda buff+$14
                asl
                lda #"H"
                bcs *+4
                lda #"-"
                jsr newchrout_t
                lda #32
		jsr newchrout_t

                lda buff+$18
                and #FATTR_CLOSED | FTYPE_MASK
                cmp #FTYPE_DIR
		bne np
                lda #32
                ldx #10
n               jsr newchrout_t
                dex
                bne n
                geq np2
                
np		jsr printsize
np2
                lda #32
                jsr newchrout_t
                
                ldx #"1"
                ldy #"9"
                lda buff+$1e
                and #%00111111
                pha
                cmp #20
                bcc *+6
                ldx #"2"
                ldy #"0"
                txa
                jsr newchrout_t
                tya
                jsr newchrout_t
                pla
                clc
                adc #80
                cmp #100
                bcc *+4
                sbc #100                

		jsr num
                lda #"-"
                jsr newchrout_t

                lda buff+$1c
                asl
                rol
                rol
                sta tmp
                lda buff+$1d
                asl
                rol tmp
                asl
                lda tmp
                rol
                and #%00001111
                jsr num
                lda #"-"
                jsr newchrout_t
                lda buff+$1f
                and #%00011111
                jsr num
                lda #32
                jsr newchrout_t
                lda buff+$1e
                and #%11000000
                sta tmp
                lda buff+$1f
                lsr
                lsr
                ora tmp
                lsr
                lsr
                lsr
                jsr num
                lda #":"
		jsr newchrout_t
                lda buff+$1d
                and #%00111111
                jsr num
                lda #":"
		jsr newchrout_t
                lda buff+$1c
                and #%00111111
                jsr num
                
                lda #32
		jsr newchrout_t
		jsr newchrout_t
                
                lda #34
		jsr newchrout_t
                
                clc
                ldy #16
                ldx #0
                jsr printname
                jsr pad
                lda #32
                jsr newchrout_t
                ldy #3
                ldx #$19
                jsr printname
                jsr pad2

                bit buff+$14
                bvc chs
                ldx #0
                ldy #3
luo             lda buff+$14,y
                sta buff+$10,x
                inx
                dey
                bpl luo
                and #15
                sta buff+$13
                jsr printsize
                #jmps nk

chs		lda #32
		jsr newchrout_t
		lda buff+$15
		ldx buff+$16
                jsr printaxnum
                lda #"/"
		jsr newchrout_t
		lda buff+$14
                and #$0f
		tax
		lda #0                
                jsr printaxnum
                lda #"/"
		jsr newchrout_t
		ldx buff+$17
		lda #0                
                jsr printaxnum
                
nk              pla
                beq re                
fileerror	jmp bas_close
;------------
r1581		jsr bas_xchrin
		lda #229
                gne nd

r1541		ldx #141
nu		jsr bas_xchrin
                dex
                bne nu
                
                lda #89
nd              sta tmp
                
                lda #34
                jsr newchrout_t

                ldx #23
nu2		jsr bas_xchrin
                cpx #7
                bne *+4
                lda #34
                cmp #$a0
                beq sp
                cpx #6
                bne *+4
sp              lda #32
		jsr newchrout_t
                dex
                bne nu2

                ldx tmp
nu3     	jsr bas_xchrin
                dex
                bne nu3

jj              lda #8
                sta tmp
                gne jju

wu              jsr check_stop
		beq fileerror
		dec tmp
		beq jj
                jsr bas_xchrin
                jsr bas_xchrin
jju		ldx #0
nu4	   	jsr bas_xchrin
		sta buff,x
                inx
                cpx #30
                bne nu4

		lda buff
                and #%10000111
                beq wu
                .if SUPERCPU=1
                ldx Status
                phx
                .else
                tax
                lda Status
                pha
                txa
                .fi
                and #%00001111
                cmp #8
                bcc *+4
                lda #7
                pha
                tax
                lda #13
                jsr newchrout_t
                lda type,x
                jsr newchrout_t

                lda buff
                asl
                pha
                lda #"-"
                bcs *+4
                lda #"*"
                jsr newchrout_t

		pla
                asl
                lda #"W"
                bcc *+4
                lda #"-"
                jsr newchrout_t
                
                ldy #5
                jsr pad2
                
                jsr printsize16
                
                lda #32
                jsr newchrout_t
                
                ldx #"1"
                ldy #"9"
                lda buff+$17
                cmp #100
                bcc *+4
                sbc #100
                pha
                cmp #80
                bcs *+6
                ldx #"2"
                ldy #"0"
                txa
                jsr newchrout_t
                tya
                jsr newchrout_t
                pla
		jsr num
                lda #"-"
                jsr newchrout_t
                lda buff+$18
                jsr num
                lda #"-"
                jsr newchrout_t
                lda buff+$19
                jsr num
                lda #" "
                jsr newchrout_t
                lda buff+$1a
                jsr num
                lda #":"
                jsr newchrout_t
                lda buff+$1b
                jsr num

		ldy #5
                jsr pad2

                lda #34
                jsr newchrout_t

		ldy #16
		ldx #3
neu		lda buff,x
		cmp #$a0
                beq jku
                jsr newchrout_t
                inx
                dey
                bne neu
jku             jsr pad

		lda #32
                jsr newchrout_t
                
                #plx_a
                lda type,x
                jsr newchrout_t
                lda type2,x
                jsr newchrout_t
                lda type3,x
                jsr newchrout_t
                lda #32
                jsr newchrout_t

                lda buff+$02
                pha
                ldx buff+$01
                lda #0
                jsr printaxnum
                lda #"/"
                jsr newchrout_t
                #plx_a
                lda #0
                jsr printaxnum

		pla
                beq wu
                gne bas_close
type            .text "DSPURCD?"
type2           .text "EERSEBI?"
type3           .text "LQGRLMR?"
		
;------------
num		sec
		ldx #47
o               inx
                sbc #10
                bcs o
                adc #58
                tay
                txa
                jsr newchrout_t
                tya
                jmp newchrout_t
;------------
printname     
ne		lda buff,x
                beq jk
                jsr newchrout_t
                inx
                dey
                bne ne
jk              rts
;------------
pad		lda #34
xi		jsr newchrout_t
;------------
pad2            lda #32
                dey
                bpl xi
		rts
;------------
m_ascii		= $69

printsize16     jsr zero
		ldy #16
		php
		sei
		sed
p2		asl buff+$1c
		rol buff+$1d
		ldx #2
p		lda m_ascii+2,x
		adc m_ascii+2,x
		sta m_ascii+2,x
		dex
		bpl p
		dey
		bne p2
		geq in
;------------                
zero            #stz_a m_ascii
		#stz_aa m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3
		#stz_aa m_ascii+4
                rts
;------------
printsize       jsr zero
		ldy #32
		php
		sei
		sed
p2k     	asl buff+$10
		rol buff+$11
		rol buff+$12
		rol buff+$13
		ldx #4
pk      	lda m_ascii,x
		adc m_ascii,x
		sta m_ascii,x
		dex
		bpl pk
		dey
		bne p2k
in		plp
		ldx #137

		lda m_ascii
		jsr h
		lda m_ascii+1
		jsr h
		lda m_ascii+2
		jsr h
		lda m_ascii+3
		jsr h
		lda m_ascii+4
;------------
h		pha
		lsr
		lsr
		lsr
		lsr
		jsr aa
		pla
aa		and #15
		bne r2
		dex
		bmi r
r2		ora #$30
		tax
                .byte SKIP2
r               lda #32
                jmp newchrout_t
;------------
ft		.byte ".-RDL"
fa		.byte "XWRDC"
                .pend
;---------------------------------------
;Basic CHANGE
;---------------------------------------
baschange      	.proc
		jsr bas_optional_devnum

		ldx #<s8
		ldy #>s8
                lda ActualDev
                cmp #8
                bne *+6
		ldx #<sd
		ldy #>sd
                jsr bas_commandc

                jsr bas_open15
                jmp bas_checkerrorclose
s8              .text "S-8",0
sd              .text "S-D",0
;---------------------------------------
;Jump far
;
far		.proc
                #psr back
                #psr switch_16k
                #phy_a
                #phx_a
                jmp exit2basic
back    	rts
		.pend
;------------                
bas_optional_name_and_devnum .proc
		jsr newchrgot
                bne bas_required_name_and_devnum.in
                #lda0
                sta ActualFNLength
                geq bas_devcheck
;------------                
bas_required_name_and_devnum .proc
		jsr newchrgot
                beq bas_missingname
in              ldx #<($e257-1)
                ldy #>($e257-1)
                jsr far
                jsr newchrgot
                beq bas_devcheck
                ldx #<($e200-1)
                ldy #>($e200-1)
                gne bas_optional_devnum.in
;------------
bas_optional_devnum .proc
                ldx #<($b79e-1)
                ldy #>($b79e-1)
in		jsr newchrgot
                beq skip
                jsr far
                stx ActualDev
skip
;------------
bas_devcheck	.proc
		lda ActualDev
		cmp #4
                bcc bas_illegaldev
                cmp #31
                bcs bas_illegaldev
                rts
;------------
bas_filenotf	.proc
		lda #$04
                .byte SKIP2
bas_missingname	.proc
		lda #$08
                .byte SKIP2
bas_toomanyfile	.proc
		lda #$01
                .byte SKIP2
bas_outofmemory	.proc
		lda #$10
                .byte SKIP2
bas_illegaldev  .proc
		lda #$09       	;illegal device
                
bas_ioerror     .proc
		.if SUPERCPU=0
                tax
                .fi
                .if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                #sta_cfg_open
                lda #0
                sta JiffyDos_internal_exp
                .fi
                #psr $e0f9
                .if SUPERCPU=0
                txa
                .fi
                jmp exit2basic
                .pend
;------------                
bas_open15	lda #15
bas_openthis	sta ActualSecAddr
bas_open      	.proc
		jsr bas_open_common
		ldx ActualLogical
		jsr newchkin_t
                bcs bas_ioerror
                rts
                .pend

bas_open2      	.proc
		jsr bas_open_common
		ldx ActualLogical
		jsr newchkout_t
                bcs bas_ioerror
                rts
                .pend

bas_open_common .proc
		jsr OP_findunusedchannel;cfg_open after
                bcs bas_toomanyfile
                .if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                lda #1
                sta JiffyDos_internal_exp
                .fi
		jsr newopen_t
                bcs bas_ioerror
                rts
                .pend
;------------
bas_close	.proc
		lda ActualLogical	;Close file
		jsr newclose_t
                bcs bas_ioerror
		jsr newclrchn_t
		.if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                #sta_cfg_open
                lda #0
                sta JiffyDos_internal_exp
                .fi
                rts
                .pend
;------------
bas_xchrin     	.proc
		jsr newchrin_t
		ldy Status
		beq oekj
		pla
		pla
		#jmps bas_close
oekj		rts
		.pend
                
bas_checkerrorclose .proc
		jsr newchrin_t
                eor #"0"
                cmp #1
                eor #"0"
                php
cuc             plp
		php
                bcc nomess
		bit msgmode
		bpl nomess
		jsr newchrout_t
nomess		lda Status
                bne xnx
                jsr newchrin_t
                bcc cuc
xnx             jsr bas_close
		plp
		rts
                .pend
;------------
; used by save and monitor too!
;
OP_findunusedchannel .proc
		sta cfg_open
		#lda0
                sta ActualLogical
		jsr search_logical_A	;Out of files?
                sec
		bne err
	     	lda #128
lp		#sbc1c
		jsr search_logical_A
		beq lp
		sta ActualLogical
                clc
err		rts
		.pend

;---------------------------------------