;
; crosslnk.asm - Cross bank jumper
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; Generated automatically. DO NOT EDIT!
;
			.if BANK=0
append_status_dec       sta bank_port1                  ;0000 -> 0006
			jsr OP_check_partition_selection;0003 <- BANK1
exitbank1               sta bank_port1                  ;0006
			rts				;0009
call_setup              sta bank_port1                  ;000A -> 0010
			jsr set_power_management_and_features;000D <- BANK1
                        sta bank_port1                  ;0010
			rts				;0013
iecin                   sta bank_port1                  ;0014 -> 001A
			jsr LWOP_timestamp              ;0017 <- BANK2
exitbank2               sta bank_port2                  ;001A
			rts				;001D
check_drive             sta bank_port2                  ;001E -> 0024
			jsr OP_check_partition_selection;0021 <- BANK2
                        sta bank_port2                  ;0024
			rts				;0027
find_free_sector        sta bank_port2                  ;0028 -> 002E
			jsr OP_init_buffer_pointers     ;002B <- BANK2
                        sta bank_port2                  ;002E
			rts				;0031
OP_XIT_do_command_channel sta bank_port2                  ;0032 -> 0038
			jsr OP_XIT_init_filesystem_from_disk;0035 <- BANK2
                        sta bank_port2                  ;0038
			rts				;003B
OP_XIT_execute_15command_open sta bank_port2                  ;003C -> 0042
			jsr search_buffer_A             ;003F <- BANK2
                        sta bank_port2                  ;0042
			rts				;0045
rewrite_file            sta bank_port2                  ;0046 -> 004C
			jsr XIT_flush_buf               ;0049 <- BANK2
                        sta bank_port2                  ;004C
			rts				;004F
update_filelen          sta bank_port2                  ;0050 -> 0056
			jsr LWNO_set_new314vect         ;0053 <- BANK3
exitbank3               sta bank_port3                  ;0056
			rts				;0059
pclink_chrin            sta bank_port3                  ;005A -> 0060
			jsr LWOP_init_c128key           ;005D <- BANK3
                        sta bank_port3                  ;0060
			rts				;0063
pclink_close            sta bank_port3                  ;0064 -> 006A
			jsr OP_check_partition_selection;0067 <- BANK3
                        sta bank_port3                  ;006A
			rts				;006D
pclink_open             sta bank_port3                  ;006E -> 0074
			jsr OP_findunusedchannel        ;0071 <- BANK3
                        sta bank_port3                  ;0074
			rts				;0077
pclink_save             sta bank_port3                  ;0078 -> 007E
			jsr OP_XIT_hdinit_2             ;007B <- BANK3
                        sta bank_port3                  ;007E
			rts				;0081
XIT_dir_first           sta bank_port3                  ;0082 -> 0088
			jmp hackedb2                    ;0085 <- BANK3
XIT_dirlp2              sta bank_port3                  ;0088 -> 008E
			rts				;008B
			.text "64"			;008C
ieclisten               sta bank_port1                  ;008E -> 0094
			rts				;0091
			.text "64"			;0092
			jmp listbank0                   ;0094 <- BANK3
			rts				;0097
manager                 sta bank_port2                  ;0098
monitor                 sta bank_port3                  ;009B
			.text "C64"			;009E
iecout                  sta bank_port1                  ;00A1 -> 00A7
newconsole              sta bank_port3                  ;00A4
			jmp mymisc                      ;00A7 <- BANK3
			rts				;00AA
			.text "64"			;00AB
			jmp overt                       ;00AD <- BANK3
iectalk                 sta bank_port1                  ;00B0 -> 00B6
			.text "C64"			;00B3
iectksa                 sta bank_port1                  ;00B6 -> 00BC
			rts				;00B9
			.text "64"			;00BA
iecunlisten             sta bank_port1                  ;00BC -> 00C2
			rts				;00BF
			.text "64"			;00C0
iecuntalk               sta bank_port1                  ;00C2 -> 00C8
			rts				;00C5
			.text "64"			;00C6
iecsecond               sta bank_port1                  ;00C8 -> 00CE
			rts				;00CB
			.text "64"			;00CC
LWOP_disk_status        sta bank_port1                  ;00CE -> 00D4
			rts				;00D1
			.text "64"			;00D2
LWOP_get_cmos_setup     sta bank_port1                  ;00D4 -> 00DA
			rts				;00D7
			.text "64"			;00D8
LWOP_read_clock         sta bank_port1                  ;00DA -> 00E0
			rts				;00DD
			.text "64"			;00DE
newload                 sta bank_port1                  ;00E0
			rts				;00E3
newread                 sta bank_port1                  ;00E4
newwrite                sta bank_port1                  ;00E7
OP_atapi_command        sta bank_port1                  ;00EA -> 00F0
			.text "C64"			;00ED
OP_atapi_packet         sta bank_port1                  ;00F0 -> 00F6
			rts				;00F3
			.text "64"			;00F4
OP_copy_filename_to_path sta bank_port1                  ;00F6 -> 00FC
			rts				;00F9
			.text "64"			;00FA
OP_load_loading_end     sta bank_port1                  ;00FC -> 0102
			rts				;00FF
			.text "64"			;0100
OP_save_saving          sta bank_port1                  ;0102 -> 0108
			rts				;0105
			.text "64"			;0106
OP_XIT_resolv_path_part sta bank_port1                  ;0108 -> 010E
			rts				;010B
XIT_finalize_direntry   sta bank_port2                  ;010C -> 0112
			.text "64"			;010F
			rts				;0111
XIT_find_free_flush     sta bank_port2                  ;0112 -> 0118
			rts				;0115
			.text "64"			;0116
XIT_init_drive          sta bank_port2                  ;0118 -> 011E
			rts				;011B
			.text "64"			;011C
XIT_load_tree           sta bank_port2                  ;011E -> 0124
			rts				;0121
			.text "64"			;0122
XIT_prealloc_dir_sector sta bank_port2                  ;0124 -> 012A
			rts				;0127
			.text "64"			;0128
XIT_read_a_sector       sta bank_port2                  ;012A -> 0130
			rts				;012D
			.text "64"			;012E
XIT_read_in_buffer      sta bank_port2                  ;0130 -> 0136
			rts				;0133
			.text "64"			;0134
XIT_save_tree           sta bank_port2                  ;0136 -> 013C
			rts				;0139
			.text "64"			;013A
XIT_write_a_sector      sta bank_port2                  ;013C -> 0142
			rts				;013F
			.text "64"			;0140
XIT_write_out_buffer    sta bank_port2                  ;0142 -> 0148
			rts				;0145
			.text "IDE64"			;0146
			rts				;014B
			.text "IDE64"			;014C
			.text "IDE64"			;0151
			.text "!"			;0156
lba2chs                 sta bank_port2                  ;0157 -> 015D
			.text "IDE64"			;015A
			.text "!"			;015F
			rts				;0160
			.text "IDE64"			;0161
			.text "C64"			;0166
XIT_read_a_sector2      sta bank_port2                  ;0169 -> 016F
			.text "IDE64"			;016C
			.text "!"			;0171
			rts				;0172
			.fi

			.if BANK=1
OP_check_partition_selection sta bank_port0                  ;0000 -> 0006
			jsr append_status_dec           ;0003 <- BANK0
exitbank0               sta bank_port0                  ;0006
			rts				;0009
set_power_management_and_features sta bank_port0                  ;000A -> 0010
			jsr call_setup                  ;000D <- BANK0
                        sta bank_port0                  ;0010
			rts				;0013
OP_read_to_direntry     sta bank_port3                  ;0014 -> 001A
			jsr iecin                       ;0017 <- BANK0
                        sta bank_port0                  ;001A
			rts				;001D
			.text "64"			;001E
			jsr append_status_dec           ;0020 <- BANK3
exitbank3               sta bank_port3                  ;0023
pclink_load             sta bank_port3                  ;0026 -> 002C
			.text "IDE64"			;0029
			.text "!"			;002E
			rts				;002F
			.text "64"			;0030
			jsr iecin                       ;0032 <- BANK3
                        sta bank_port3                  ;0035
XIT_dir_first           sta bank_port3                  ;0038 -> 003E
			.text "IDE64"			;003B
			.text "!"			;0040
			rts				;0041
			.text "64"			;0042
			jsr ieclisten                   ;0044 <- BANK3
                        sta bank_port3                  ;0047
monitor                 sta bank_port3                  ;004A
			.text "C64"			;004D
XIT_dirlp2              sta bank_port3                  ;0050 -> 0056
			jsr append_status_dec           ;0053 <- BANK2
exitbank2               sta bank_port2                  ;0056
			rts				;0059
check_drive             sta bank_port2                  ;005A -> 0060
			jsr is_special_s                ;005D <- BANK2
                        sta bank_port2                  ;0060
			rts				;0063
find_free_sectors_tree  sta bank_port2                  ;0064 -> 006A
			jsr LWOP_disk_status            ;0067 <- BANK2
                        sta bank_port2                  ;006A
			rts				;006D
linearaccess            sta bank_port2                  ;006E -> 0074
			jsr OP_delimiter_in_path        ;0071 <- BANK2
                        sta bank_port2                  ;0074
			rts				;0077
XIT_init_drive          sta bank_port2                  ;0078 -> 007E
			jsr OP_get_partnum              ;007B <- BANK2
                        sta bank_port2                  ;007E
			rts				;0081
XIT_load_tree           sta bank_port2                  ;0082 -> 0088
			jsr OP_short_path               ;0085 <- BANK2
                        sta bank_port2                  ;0088
			rts				;008B
			.text "IDE64"			;008C
			jsr ieclisten                   ;0091 <- BANK0
                        sta bank_port0                  ;0094
			jsr iecout                      ;0097 <- BANK3
                        sta bank_port3                  ;009A
			jsr iectalk                     ;009D <- BANK3
                        sta bank_port3                  ;00A0
			.text "!"			;00A3
			jsr iecout                      ;00A4 <- BANK0
                        sta bank_port0                  ;00A7
			jsr OP_XIT_partnum_delimiter    ;00AA <- BANK2
                        sta bank_port2                  ;00AD
			.text "C64"			;00B0
			jsr iectalk                     ;00B3 <- BANK0
                        sta bank_port0                  ;00B6
			jsr iectksa                     ;00B9 <- BANK0
                        sta bank_port0                  ;00BC
			jsr iecunlisten                 ;00BF <- BANK0
                        sta bank_port0                  ;00C2
			jsr iecuntalk                   ;00C5 <- BANK0
                        sta bank_port0                  ;00C8
			jsr iecsecond                   ;00CB <- BANK0
                        sta bank_port0                  ;00CE
			jsr LWOP_disk_status            ;00D1 <- BANK0
                        sta bank_port0                  ;00D4
			jsr LWOP_get_cmos_setup         ;00D7 <- BANK0
                        sta bank_port0                  ;00DA
			jsr LWOP_read_clock             ;00DD <- BANK0
                        sta bank_port0                  ;00E0
			jmp newload                     ;00E3 <- BANK0
			.text "!"			;00E6
			jmp newread                     ;00E7 <- BANK0
			jmp newwrite                    ;00EA <- BANK0
			jsr OP_atapi_command            ;00ED <- BANK0
                        sta bank_port0                  ;00F0
			jsr OP_atapi_packet             ;00F3 <- BANK0
                        sta bank_port0                  ;00F6
			jsr OP_copy_filename_to_path    ;00F9 <- BANK0
                        sta bank_port0                  ;00FC
			jsr OP_load_loading_end         ;00FF <- BANK0
                        sta bank_port0                  ;0102
			jsr OP_save_saving              ;0105 <- BANK0
                        sta bank_port0                  ;0108
			jsr OP_XIT_resolv_path_part     ;010B <- BANK0
                        sta bank_port0                  ;010E
			jsr iectksa                     ;0111 <- BANK3
                        sta bank_port3                  ;0114
			jsr iecunlisten                 ;0117 <- BANK3
                        sta bank_port3                  ;011A
			jsr iecuntalk                   ;011D <- BANK3
                        sta bank_port3                  ;0120
			jsr iecsecond                   ;0123 <- BANK3
                        sta bank_port3                  ;0126
			jsr LWOP_disk_status            ;0129 <- BANK3
                        sta bank_port3                  ;012C
			jsr LWOP_read_clock             ;012F <- BANK3
                        sta bank_port3                  ;0132
			jsr OP_short_path               ;0135 <- BANK3
                        sta bank_port3                  ;0138
			jsr check_wildcards             ;013B <- BANK3
                        sta bank_port3                  ;013E
			jsr check_wildtype              ;0141 <- BANK3
                        sta bank_port3                  ;0144
			.text "!"			;0147
XIT_read_a_sector       sta bank_port2                  ;0148 -> 014E
			.text "C64"			;014B
XIT_save_tree           sta bank_port2                  ;014E -> 0154
			rts				;0151
			.text "IDE64"			;0152
			rts				;0157
			.text "64"			;0158
			jsr OP_XIT_resolv_path          ;015A <- BANK2
                        sta bank_port2                  ;015D
XIT_upload_next_sector  sta bank_port2                  ;0160 -> 0166
			jsr OP_path_searchtype          ;0163 <- BANK3
                        sta bank_port3                  ;0166
			rts				;0169
			.text "64"			;016A
			jsr OP_XIT_resolv_path_part     ;016C <- BANK2
                        sta bank_port2                  ;016F
			jsr OP_save_saving              ;0172 <- BANK3
                        sta bank_port3                  ;0175
			jsr OP_XIT_resolv_path_part     ;0178 <- BANK3
                        sta bank_port3                  ;017B
			jsr OP_load_loading             ;017E <- BANK3
                        sta bank_port3                  ;0181
			.fi

			.if BANK=2
channel15_cont          sta bank_port3                  ;0000 -> 0006
			jsr numtoasc16                  ;0003 <- BANK3
exitbank3               sta bank_port3                  ;0006
			rts				;0009
getcconv                sta bank_port3                  ;000A -> 0010
			jsr XIT_init_drive              ;000D <- BANK3
                        sta bank_port3                  ;0010
			rts				;0013
LWOP_timestamp          sta bank_port0                  ;0014 -> 001A
			.text "IDE64"			;0017
			.text "!"			;001C
			rts				;001D
OP_check_partition_selection sta bank_port0                  ;001E -> 0024
			jsr check_drive                 ;0021 <- BANK0
exitbank0               sta bank_port0                  ;0024
			rts				;0027
OP_init_buffer_pointers sta bank_port0                  ;0028 -> 002E
			jsr find_free_sector            ;002B <- BANK0
                        sta bank_port0                  ;002E
			rts				;0031
OP_XIT_init_filesystem_from_disk sta bank_port0                  ;0032 -> 0038
			jsr OP_XIT_do_command_channel   ;0035 <- BANK0
                        sta bank_port0                  ;0038
			rts				;003B
search_buffer_A         sta bank_port0                  ;003C -> 0042
			jsr OP_XIT_execute_15command_open;003F <- BANK0
                        sta bank_port0                  ;0042
			rts				;0045
XIT_flush_buf           sta bank_port0                  ;0046 -> 004C
			jsr rewrite_file                ;0049 <- BANK0
                        sta bank_port0                  ;004C
			rts				;004F
append_status_dec       sta bank_port1                  ;0050 -> 0056
			jsr update_filelen              ;0053 <- BANK0
                        sta bank_port0                  ;0056
			rts				;0059
is_special_s            sta bank_port1                  ;005A -> 0060
			jsr check_drive                 ;005D <- BANK1
exitbank1               sta bank_port1                  ;0060
			rts				;0063
LWOP_disk_status        sta bank_port1                  ;0064 -> 006A
			jsr find_free_sectors_tree      ;0067 <- BANK1
                        sta bank_port1                  ;006A
			rts				;006D
OP_delimiter_in_path    sta bank_port1                  ;006E -> 0074
			jsr linearaccess                ;0071 <- BANK1
                        sta bank_port1                  ;0074
			rts				;0077
OP_get_partnum          sta bank_port1                  ;0078 -> 007E
			jsr XIT_init_drive              ;007B <- BANK1
                        sta bank_port1                  ;007E
			rts				;0081
OP_short_path           sta bank_port1                  ;0082 -> 0088
			jsr XIT_load_tree               ;0085 <- BANK1
                        sta bank_port1                  ;0088
			rts				;008B
			.text "IDE64"			;008C
			.text "IDE64"			;0091
			.text "IDE64"			;0096
			jmp manager                     ;009B <- BANK0
			.text "IDE64"			;009E
			.text "SOCI"			;00A3
OP_XIT_partnum_delimiter sta bank_port1                  ;00A7 -> 00AD
			.text "IDE64"			;00AA
			.text "!"			;00AF
			rts				;00B0
			jsr XIT_init_drive2             ;00B1 <- BANK3
                        sta bank_port3                  ;00B4
			jsr chs2lba                     ;00B7 <- BANK3
                        sta bank_port3                  ;00BA
			jsr lba2chs                     ;00BD <- BANK3
                        sta bank_port3                  ;00C0
			jsr XIT_upload_next_sector      ;00C3 <- BANK3
                        sta bank_port3                  ;00C6
			.text "IDE64"			;00C9
			.text "IDE64"			;00CE
			.text "IDE64"			;00D3
			.text "IDE64"			;00D8
			.text "IDE64"			;00DD
			.text "IDE64"			;00E2
			.text "IDE64"			;00E7
			.text "IDE64"			;00EC
			.text "IDE64"			;00F1
			.text "IDE64"			;00F6
			.text "IDE64"			;00FB
			.text "IDE64"			;0100
			.text "IDE64"			;0105
			.text "IDE64"			;010A
			jsr XIT_finalize_direntry       ;010F <- BANK0
                        sta bank_port0                  ;0112
			jsr XIT_find_free_flush         ;0115 <- BANK0
                        sta bank_port0                  ;0118
			jsr XIT_init_drive              ;011B <- BANK0
                        sta bank_port0                  ;011E
			jsr XIT_load_tree               ;0121 <- BANK0
                        sta bank_port0                  ;0124
			jsr XIT_prealloc_dir_sector     ;0127 <- BANK0
                        sta bank_port0                  ;012A
			jsr XIT_read_a_sector           ;012D <- BANK0
                        sta bank_port0                  ;0130
			jsr XIT_read_in_buffer          ;0133 <- BANK0
                        sta bank_port0                  ;0136
			jsr XIT_save_tree               ;0139 <- BANK0
                        sta bank_port0                  ;013C
			jsr XIT_write_a_sector          ;013F <- BANK0
                        sta bank_port0                  ;0142
			jsr XIT_write_out_buffer        ;0145 <- BANK0
                        sta bank_port0                  ;0148
			jsr XIT_read_a_sector           ;014B <- BANK1
                        sta bank_port1                  ;014E
			jsr XIT_save_tree               ;0151 <- BANK1
                        sta bank_port1                  ;0154
OP_XIT_resolv_path      sta bank_port1                  ;0157 -> 015D
			jsr lba2chs                     ;015A <- BANK0
                        sta bank_port0                  ;015D
			rts				;0160
			.text "64"			;0161
			jsr XIT_upload_next_sector      ;0163 <- BANK1
                        sta bank_port1                  ;0166
OP_XIT_resolv_path_part sta bank_port1                  ;0169 -> 016F
			jsr XIT_read_a_sector2          ;016C <- BANK0
                        sta bank_port0                  ;016F
			rts				;0172
			.fi

			.if BANK=3
numtoasc16              sta bank_port2                  ;0000 -> 0006
			jsr channel15_cont              ;0003 <- BANK2
exitbank2               sta bank_port2                  ;0006
			rts				;0009
XIT_init_drive          sta bank_port2                  ;000A -> 0010
			jsr getcconv                    ;000D <- BANK2
                        sta bank_port2                  ;0010
			rts				;0013
			.text "C64"			;0014
			jsr OP_read_to_direntry         ;0017 <- BANK1
exitbank1               sta bank_port1                  ;001A
append_status_dec       sta bank_port1                  ;001D -> 0023
			.text "IDE64"			;0020
			.text "!"			;0025
			rts				;0026
			.text "64"			;0027
			jsr pclink_load                 ;0029 <- BANK1
                        sta bank_port1                  ;002C
iecin                   sta bank_port1                  ;002F -> 0035
			.text "IDE64"			;0032
			.text "!"			;0037
			rts				;0038
			.text "64"			;0039
			jsr XIT_dir_first               ;003B <- BANK1
                        sta bank_port1                  ;003E
ieclisten               sta bank_port1                  ;0041 -> 0047
			.text "IDE64"			;0044
			.text "!"			;0049
			rts				;004A
			.text "64"			;004B
			jmp monitor                     ;004D <- BANK1
LWNO_set_new314vect     sta bank_port0                  ;0050 -> 0056
			jsr XIT_dirlp2                  ;0053 <- BANK1
                        sta bank_port1                  ;0056
			rts				;0059
LWOP_init_c128key       sta bank_port0                  ;005A -> 0060
			jsr pclink_chrin                ;005D <- BANK0
exitbank0               sta bank_port0                  ;0060
			rts				;0063
OP_check_partition_selection sta bank_port0                  ;0064 -> 006A
			jsr pclink_close                ;0067 <- BANK0
                        sta bank_port0                  ;006A
			rts				;006D
OP_findunusedchannel    sta bank_port0                  ;006E -> 0074
			jsr pclink_open                 ;0071 <- BANK0
                        sta bank_port0                  ;0074
			rts				;0077
OP_XIT_hdinit_2         sta bank_port0                  ;0078 -> 007E
			jsr pclink_save                 ;007B <- BANK0
                        sta bank_port0                  ;007E
			rts				;0081
hackedb2                sta bank_port0                  ;0082
			jsr XIT_dir_first               ;0085 <- BANK0
                        sta bank_port0                  ;0088
			jsr XIT_dirlp2                  ;008B <- BANK0
                        sta bank_port0                  ;008E
listbank0               sta bank_port0                  ;0091
iecout                  sta bank_port1                  ;0094 -> 009A
			.text "C64"			;0097
iectalk                 sta bank_port1                  ;009A -> 00A0
			rts				;009D
			jmp monitor                     ;009E <- BANK0
			.text "64"			;00A1
			rts				;00A3
mymisc                  sta bank_port0                  ;00A4
			jmp newconsole                  ;00A7 <- BANK0
overt                   sta bank_port0                  ;00AA
			.text "!"			;00AD
XIT_init_drive2         sta bank_port2                  ;00AE -> 00B4
			.text "C64"			;00B1
chs2lba                 sta bank_port2                  ;00B4 -> 00BA
			rts				;00B7
			.text "64"			;00B8
lba2chs                 sta bank_port2                  ;00BA -> 00C0
			rts				;00BD
			.text "64"			;00BE
XIT_upload_next_sector  sta bank_port2                  ;00C0 -> 00C6
			rts				;00C3
			.text "IDE64"			;00C4
			rts				;00C9
			.text "IDE64"			;00CA
			.text "IDE64"			;00CF
			.text "IDE64"			;00D4
			.text "IDE64"			;00D9
			.text "IDE64"			;00DE
			.text "IDE64"			;00E3
			.text "IDE64"			;00E8
			.text "IDE64"			;00ED
			.text "IDE64"			;00F2
			.text "IDE64"			;00F7
			.text "IDE64"			;00FC
			.text "IDE64"			;0101
			.text "IDE64"			;0106
			.text "C64"			;010B
iectksa                 sta bank_port1                  ;010E -> 0114
			.text "C64"			;0111
iecunlisten             sta bank_port1                  ;0114 -> 011A
			rts				;0117
			.text "64"			;0118
iecuntalk               sta bank_port1                  ;011A -> 0120
			rts				;011D
			.text "64"			;011E
iecsecond               sta bank_port1                  ;0120 -> 0126
			rts				;0123
			.text "64"			;0124
LWOP_disk_status        sta bank_port1                  ;0126 -> 012C
			rts				;0129
			.text "64"			;012A
LWOP_read_clock         sta bank_port1                  ;012C -> 0132
			rts				;012F
			.text "64"			;0130
OP_short_path           sta bank_port1                  ;0132 -> 0138
			rts				;0135
			.text "64"			;0136
check_wildcards         sta bank_port1                  ;0138 -> 013E
			rts				;013B
			.text "64"			;013C
check_wildtype          sta bank_port1                  ;013E -> 0144
			rts				;0141
			.text "IDE64"			;0142
			rts				;0147
			.text "IDE64"			;0148
			.text "IDE64"			;014D
			.text "IDE64"			;0152
			.text "IDE64"			;0157
			.text "SOCI"			;015C
OP_path_searchtype      sta bank_port1                  ;0160 -> 0166
			.text "IDE64"			;0163
			.text "!"			;0168
			rts				;0169
			.text "IDE64"			;016A
OP_save_saving          sta bank_port1                  ;016F -> 0175
			.text "C64"			;0172
OP_XIT_resolv_path_part sta bank_port1                  ;0175 -> 017B
			rts				;0178
			.text "64"			;0179
OP_load_loading         sta bank_port1                  ;017B -> 0181
			rts				;017E
			.text "IDE64"			;017F
			rts				;0184
			.fi

